#pragma once
/*
 * Copyright (C) the qig contributors. All rights reserved.
 *
 * This file is part of libgit2, distributed under the GNU GPL v3 with
 * a Linking Exception. For full terms see the included COPYING file.
 */
namespace qig
{
  enum branchType
  {
    /// indicate local branch
    branchTypeLocal=1,
    /// indicate remote branch
    branchTypeRemote=2,
    /// when searching for a branches the branch type will be ignored
    branchTypeAll=branchTypeLocal|branchTypeRemote
  };

  namespace revwalk
  {
    /// the sorting method in rev walk
    enum revwalkSort
    {
      revwalkSortNone	  = 0,
      /// traverse depth first
      revwalkSortTopology = 1,
      /// sort for commit date
      revwalkSortTime	  = 2,
      /// start at the bottom.
      revwalkSortReverse  = 4
    };
  }
  typedef revwalk::revwalkSort revwalkSort;

  enum objectType
  {
    objectTypeAny=-2,
    objectTypeBad=-1,
    objectType_Ext1=0,
    objectTypeCommit=1,
    objectTypeTree=2,
    objectTypeBlob=3,
    objectTypeTag=4,
    objectType_Ext2=5,
    objectTypeOfsDelta=6,
    objectTypeRefDelta=7
  };

  enum errorCodes
  {
      GIT_OK         =  0,		/**< No error */

      GIT_ERROR      = -1,		/**< Generic error */
      GIT_ENOTFOUND  = -3,		/**< Requested object could not be found */
      GIT_EEXISTS    = -4,		/**< Object exists preventing operation */
      GIT_EAMBIGUOUS = -5,		/**< More than one object matches */
      GIT_EBUFS      = -6,		/**< Output buffer too short to hold data */

      /* GIT_EUSER is a special error that is never generated by libgit2
       * code.  You can return it from a callback (e.g to stop an iteration)
       * to know that it was generated by the callback and not by libgit2.
       */
      GIT_EUSER      = -7,

      GIT_EBAREREPO       =  -8,	/**< Operation not allowed on bare repository */
      GIT_EUNBORNBRANCH   =  -9,	/**< HEAD refers to branch with no commits */
      GIT_EUNMERGED       = -10,	/**< Merge in progress prevented operation */
      GIT_ENONFASTFORWARD = -11,	/**< Reference was not fast-forwardable */
      GIT_EINVALIDSPEC    = -12,	/**< Name/ref spec was not in a valid format */
      GIT_ECONFLICT       = -13,	/**< Checkout conflicts prevented operation */
      GIT_ELOCKED         = -14,	/**< Lock file prevented operation */
      GIT_EMODIFIED       = -15,	/**< Reference value does not match expected */
      GIT_EAUTH           = -16,      /**< Authentication error */
      GIT_ECERTIFICATE    = -17,      /**< Server certificate is invalid */
      GIT_EAPPLIED        = -18,	/**< Patch/merge has already been applied */
      GIT_EPEEL           = -19,      /**< The requested peel operation is not possible */
      GIT_EEOF            = -20,      /**< Unexpected EOF */
      GIT_EINVALID        = -21,      /**< Invalid operation or input */
      GIT_EUNCOMMITTED    = -22,	/**< Uncommitted changes in index prevented operation */
      GIT_EDIRECTORY      = -23,      /**< The operation is not valid for a directory */

      GIT_PASSTHROUGH     = -30,	/**< Internal only */
      GIT_ITEROVER        = -31,	/**< Signals end of iteration with iterator */
  };

  namespace logFilter
  {
    enum fields
    {
      fieldCommitHeader  ,// =0x100,			    // <<string filter
      fieldCommitMessage ,// = fieldCommitHeader<<1,   // << string filter
      fieldCommiter	 ,// = fieldCommitMessage<<1,	    // string filter
      fieldDate		 ,// = fieldCommiter<<1,	    // int filter
      fieldMergeCommit	 ,// = fieldDate<<1,	    //  << int filter on base on qigModelData. On qigCommit not applicable
      fieldForkCommit	 ,// = fieldMergeCommit<<1,    // << int filter on base of 
      fieldBranch	 ,// = fieldunknown<<1,  // < maybe use git_graph_* API
      fieldunknown	 // = fieldForkCommit<<1
    };

    enum type
    {
      typeStringFilter,
      typeGraphFilter
    };
    enum operand
    {
      less,
      equal,
      greater
    };
  }
  /** @brief values used in status to compare the current state
  // extends git_status_t by adding fileStateUndefined
  // values compared against libgits value in Status.cpp
   */
  enum fileState {
    fileStateUnchanged = 0,

    fileStateIndexNew          =                           1,
    fileStateIndexModified     = fileStateIndexNew       << 1,
    fileStateIndexDeleted      = fileStateIndexModified  << 1,
    fileStateIndexRenamed      = fileStateIndexDeleted   << 1,
    fileStateIndexTypeChange   = fileStateIndexRenamed   << 1,

    fileStateWDNew          =                       1 << 7,
    fileStateWDModified     = fileStateWDNew          << 1,
    fileStateWDDeleted      = fileStateWDModified     << 1,
    fileStateWDTypeChange   = fileStateWDDeleted      << 1,
    fileStateWDRenamed      = fileStateWDTypeChange   << 1,
    fileStateWDUnreadable   = fileStateWDRenamed      << 1,

    fileStateIgnored      =                       1 << 14,
    fileStateConflicted   = fileStateIgnored   << 1,

    fileStateUndefined = fileStateConflicted<<1
  };
  enum  modelRoles
  {
    /// same as QFileSystemModel::FilePathRole
    roleFilePath = 0x101,
    // used to retrieve oid of selected file from selected tree. returns oid of odb even file contains local modificaation that are not commited jet.
    // if no tree is selected explicitly, the most recent oid is returned. this also includes the looking for  a valid oid in the index
    roleOid = 0x104,
    /// returns a value from fileState;
    roleFileState,
    /// same as roleFilePath but returns the relative path starting at the git repository
    roleFilePathRelative,
    /// returns true (as QVariant) if current index is path;
    roleIsDir,
    /// describes the sources of the current item. return value is the enum treeSource
    roleTreeSource,
    roleBrush,
    // supported by logModel. returns list of [maybe pointer to] oids of parents.
    // normally the list contains one element except for merges
    roleParentOids,
    // supported by logModel. returns list of [maybe pointer to] oids of parents.
    // normally the list contains one element except for forks
    roleChildrenOids
  };
  enum treeSource
  {
    /// tree is the index
    treeSourceIndex,
    /// tree is the workdir
    treeSourceWD,
    /// tree is contained in ODB and described by oid
    treeSourceOid,
    /// tree is contained in ODB and described by reference
    treeSourceRef
  };
  enum applicationState
  {
    applicationStateDefault,
    applicationStateAdd,
    applicationStateCommit,
    applicationStateConflict,
  };

  enum stateTransition
  {
    /// transition does not modify the repo. does not discard any in memory changes.
    stateTransitionDefault,
    /// transition does not modify the repo and discards the changes (if any)
    stateTransitionAbort,
    /// transition modify the repo; for example by writing the index to the disk
    /// or by writing the commit to the odb
    stateTransitionAccept
  };

}
